;;
;;	SYS_INTERFACE
;;      Renders the interface of the game
;;
;;

.include "sys/render.h.s"
.include "man/interface.h.s"
.include "cpct_functions.h.s"
.include "assets/assets.h.s"

sp_heart_width      = 4
sp_heart_height     = 12

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SYS_INTERFACE:: INIT
man_interface_init::

    ;; LIFE 1
    ld      de, #screen_start       ;; [3] DE points to the beginning of the screen's memory video
    ld       c, #interface_lifes_x                   ;; [6] C = X
    ld       b, #interface_start+#interface_lifes_y  ;; [6] B = Y
    call    cpct_getScreenPtr_asm   ;; [x] Get screen address according to x and y coordinates

    ex      de,hl
    ld      hl, #_sp_shield
    ;ld      hl, #4  ;; TEMP RANDOM SPRITE

    ld      b, #sp_heart_height         
    ld      c, #sp_heart_width
    call    cpct_drawSprite_asm

    ;; LIFE 2
    ld      de, #screen_start       ;; [3] DE points to the beginning of the screen's memory video
    ld       c, #interface_lifes_x + #interface_width_between_lifes                   ;; [6] C = X
    ld       b, #interface_start+#interface_lifes_y  ;; [6] B = Y
    call    cpct_getScreenPtr_asm   ;; [x] Get screen address according to x and y coordinates

    ex      de,hl
    ld      hl, #_sp_shield
    ;ld      hl, #4  ;; TEMP RANDOM SPRITE

    ld      b, #sp_heart_height
    ld      c, #sp_heart_width
    call    cpct_drawSprite_asm

    ; LIFE 3
    ld      de, #screen_start       ;; [3] DE points to the beginning of the screen's memory video
    ld       c, #interface_lifes_x + 2*#interface_width_between_lifes                   ;; [6] C = X
    ld       b, #interface_start+#interface_lifes_y  ;; [6] B = Y
    call    cpct_getScreenPtr_asm   ;; [x] Get screen address according to x and y coordinates

    ex      de,hl
    ld      hl, #_sp_shield
    ;ld      hl, #4  ;; TEMP RANDOM SPRITE

    ld      b, #sp_heart_height
    ld      c, #sp_heart_width
    call    cpct_drawSprite_asm


    ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SYS_INTERFACE:: INIT
;; INPUT 
;;      A-Num of lifes
man_interface_update_lifes::
    
    ;; ALWAYS GONNA ERASE NEXT LIFE (IF LIFES == 2, LIFE TO ERASE == 3)
    ld      c, #interface_lifes_x+#interface_width_between_lifes
    ld      d,a    

;; CALCULATE LIFE TO ERASE
loop:

    cp #1
    jr z,end_loop

    ;; UPDATE X
    ld  a,c
    add a,#interface_width_between_lifes
    ld  c,a

    ;; UPDATE LIFE COUNTER
    dec d
    ld  a,d
    jp  loop


end_loop:
        
    ld      de, #screen_start       ;; [3] DE points to the beginning of the screen's memory video

    ld       b, #interface_start+#interface_lifes_y  ;; [6] B = Y
    call    cpct_getScreenPtr_asm   ;; [x] Get screen address according to x and y coordinates

    ex      de,hl
    ld      hl, #_sp_brokenshield
    ;ld      hl, #4  ;; TEMP RANDOM SPRITE

    ld      b, #sp_heart_height
    ld      c, #sp_heart_width
    call    cpct_drawSprite_asm

    ret