;;
;;  Level Manager
;;

;.macro  DefLevel    _levelname
;    _levelname  
;.endm  

.include "assets/assets.h.s"
.include "cmp/entity.h.s"
.include "man/patrol.h.s"

.module level_manager

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Current level pointer
current_level:  
    .dw     level_tutorial

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Level data
level_tutorial:
    .dw     _tutorial
    .dw     level_1
    .db     15, 120   ;; Second enemy
    .dw     _patrol_dont_move
    .dw     nullptr

level_1:
    .dw     _lvl1
    .dw     level_2
    .db     15, 120   ;; Second enemy
    .dw     _patrol_dont_move
    .dw     nullptr

level_2:
    .dw     _lvl2
    .dw     level_3
    .db     15, 40   ;; First enemy,
    .dw     _patrol_dont_move
    ;.db     60, 40
    ;.dw     _patrol_dont_move
    .dw     nullptr

level_3:
    .dw     _lvl3
    .dw     level_4
    .db     15, 40   ;; First enemy,
    .dw     _patrol_dont_move
    .db     50, 40
    .dw     _patrol_dont_move
    .dw     nullptr

level_4:
    .dw     _lvl4
    .dw     level_tutorial
    .db     15, 40   ;; First enemy,
    .dw     _patrol_dont_move
    .db     50, 40
    .dw     _patrol_dont_move
    .dw     nullptr


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  man_level_next_level
;;  Updates the current_level variable to the next level
;;
;;  INPUT:
;;  OUTPUT:
;;  DESTROYS:  
;;      HL, DE
man_level_next_level::
    ld    hl, #current_level    ;; HL = Current_level

    ;; Store in DE the memory address of the data of the current map
    ld       e, (hl)            
    inc     hl
    ld       d, (hl)            ;; DE = Current level data
    dec     hl                  ;; HL = Current level pointer

    inc     de                  ;; DE points to the next level afte the
    inc     de                  ;; current level

    ex      de, hl              ;; DE = Current level pointer
                                ;; HL = Current level data

    ld      c, (hl)
    inc     hl
    ld      b, (hl)             ;; BC = Memory address of next level data
    dec     hl

    ex      de, hl              ;; DE = Current level data
                                ;; HL = Current level pointer

    ld      (hl), c             ;; Store in current_level the new level data 
    inc     hl                  ;; structure
    ld      (hl), b             ;;

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  man_level_get_current_level
;;  Retrives the pointer to the current tilemap
;;
;;  INPUT:
;;  OUTPUT:
;;      DE: Pointer to the next tilemap
;;  DESTROYS:
;;      HL, DE
;;
man_level_get_current_level::
    ld      hl, #current_level  ;; HL = Current level

    ld       e, (hl)                
    inc     hl
    ld       d, (hl)            ;; DE = Current level data structure memory address
    dec     hl                  ;; HL = Current level

    ex      de, hl              ;; Exchange DE and HL
    ld      e, (hl)             ;; E = Low part of tilemap memory address
    inc     hl                  ;; HL ++
    ld      d, (hl)             ;; D = High part of memory addresss of tilemap

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  man_level_get_current_level
;;  Retrives the pointer to the current tilemap
;;
;;  INPUT:
;;  OUTPUT:
;;      DE: Pointer to the next tilemap
;;  DESTROYS:
;;      HL, DE
;;
man_level_get_current_level_data::
    ld      hl, #current_level  ;; HL = Current level

    ld       e, (hl)                
    inc     hl
    ld       d, (hl)            ;; DE = Current level data structure memory address
    ex      de, hl              ;; HL = Current level data structure

    ret

