;;
;; MENU MANAGER
;;

.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "sys/render.h.s" 	;; screen_start
.include "assets/assets.h.s"
.include "assets/menu/mainmenu.h.s"

.module menu_manager

.globl myfunc_drawString
;; ==========================================================================
;; MEMBER VARIABLES
;; ==========================================================================

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Menu
;; ==========================================================================
endMenu_X_coord = 20
endMenu_Y_coord = 88

mainMenu_X_coord = 0
mainMenu_Y_coord = 120


mainMenu_foreground_color	= #0xE  ;; Foreground color: Yellom
mainMenu_background_color	= #0 ;; Background color: Black 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Menu Keys
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 1
CKey_StartGame 		== #Key_1
;; 2
CKey_Options   		== #Key_2
;; Escape
CKey_GoToMainMenu		== #Key_Esc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Menu Ascii Strings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ascii_play_string: 		.asciz "1-PLAY"
ascii_options_string: 	.asciz "2-CONTROLS"

ascii_controls1_string: .asciz "MOVING-OPQA"
ascii_controls2_string:	.asciz "ATTACK-E"
ascii_controls3_string: .asciz "JUMP-SPACE"
ascii_back_string: 		.asciz "ESC-GO@BACK"

ascii_death_string1:	.asciz "GROMF@GROMF"
ascii_death_string2:	.asciz "MMMMMMMMMMMMMMMMMMMa"
ascii_death_string3:	.asciz "(DEMON@BLURP@SOUND)"
ascii_death_string4:	.asciz "WELL,@SEEMS"
ascii_death_string5:	.asciz "LIKE@DEMONS"
ascii_death_string6:	.asciz "FOUND@YOU@"
ascii_death_string7:	.asciz	"QUITE@DELICIOUS"

;; ==========================================================================
;; In-game Menu Keys
;; ==========================================================================
;; Space
CKey_NextLevel	== #Key_R
;; R
CKey_RestartLevel	== #Key_R

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; In-game Ascii Strings
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ascii_victory_string: 	.asciz "VICTORYa"
ascii_defeat_string: 	.asciz "GAME@OVER"
ascii_restart_string1:	.asciz "PRESS@R" 
ascii_restart_string2:	.asciz "TO@RESTARTa"

;; ==========================================================================
;; PUBLIC FUNCTIONS
;; ==========================================================================

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Man Menu::Init
;; -------------------------------------------------------------
;; 	 Draws the main menu
;; INPUT: -
;; DESTROYS: AF, BC, DE, HL, IX, IY
;;

man_mainMenu_reference::
	call clean_screen
	;; Set Character colors
	ld  h, #mainMenu_background_color
	ld	l, #3

  	call cpct_setDrawCharM0_asm
	ld	de, #screen_start
  	ld	b, #8			;; [Y] coordinate
 	ld	c, #20  		;; [X] coordinate
  	call	cpct_getScreenPtr_asm		;; Returns Video Memory position in HL	

	ld	iy, #ascii_death_string1
  	call myfunc_drawString	
	
	ld	de, #screen_start
  	ld	b, #16			;; [Y] coordinate
 	ld	c, #0  		;; [X] coordinate
  	call	cpct_getScreenPtr_asm		;; Returns Video Memory position in HL	

	ld	iy, #ascii_death_string2
  	call myfunc_drawString	

	  	ld	de, #screen_start
  	ld	b, #24			;; [Y] coordinate
 	ld	c, #0  		;; [X] coordinate
  	call	cpct_getScreenPtr_asm		;; Returns Video Memory position in HL	

	ld	iy, #ascii_death_string3
  	call myfunc_drawString	

;; Set Character colors
	ld  h, #mainMenu_background_color
	ld	l, #mainMenu_foreground_color
  	call cpct_setDrawCharM0_asm

	  	ld	de, #screen_start
  	ld	b, #40			;; [Y] coordinate
 	ld	c, #20  		;; [X] coordinate
  	call	cpct_getScreenPtr_asm		;; Returns Video Memory position in HL	

	ld	iy, #ascii_death_string4
  	call myfunc_drawString	

	  	ld	de, #screen_start
  	ld	b, #48			;; [Y] coordinate
 	ld	c, #20  		;; [X] coordinate
  	call	cpct_getScreenPtr_asm		;; Returns Video Memory position in HL	

	ld	iy, #ascii_death_string5
  	call myfunc_drawString	

	    	ld	de, #screen_start
  	ld	b, #56			;; [Y] coordinate
 	ld	c, #24  		;; [X] coordinate
  	call	cpct_getScreenPtr_asm		;; Returns Video Memory position in HL	

	ld	iy, #ascii_death_string6
  	call myfunc_drawString	


  	ld	de, #screen_start
  	ld	b, #64			;; [Y] coordinate
 	ld	c, #12  		;; [X] coordinate
  	call	cpct_getScreenPtr_asm		;; Returns Video Memory position in HL	

	ld	iy, #ascii_death_string7
  	call myfunc_drawString	


	ret


man_mainMenu_init::
	;; Set music menu
	ld	de, #_menu_song
	call	cpct_akp_musicInit_asm
	
	;; Set Character colors
	ld  h, #mainMenu_background_color
	ld	l, #mainMenu_foreground_color
  	call cpct_setDrawCharM0_asm


	call 	draw_play_menu

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Man Menu::Delete
man_mainMenu_delete::
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Man Menu::Update
;; ---------------------------------------------------------
;;   Gets keyboard inputs and applies them
;; to Main Menu Options.
;; INPUT: -
;; DESTROYS: A, D, BC, HL
;;
man_mainMenu_update::

	mainMenu_loop:
	;{
		;call    cpct_scanKeyboard_f_asm
		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		;; Check if start key was pressed
		ld      hl, #CKey_StartGame
		call    cpct_isKeyPressed_asm
		jr      z, Start_NotPressed

		Start_Pressed:
			call clean_play_menu
			ret											;; Return to Game Manager to start the game
		Start_NotPressed:	
			;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			;; Check if options key was pressed
			ld      hl, #CKey_Options
			call    cpct_isKeyPressed_asm
			jr      z, Options_NotPressed

		Options_Pressed:
			call 	clean_play_menu
			call	draw_options_menu	

			call	manageOptionsMenu
		Options_NotPressed:
			jr	mainMenu_loop
	;}


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Man Victory Menu
;; -------------------------------------------------------------
;;   Draws the end of level menu when victory conditions
;; are achieved and manages it
;; INPUT: -
;; DESTROYS: -
;;
man_victoryMenu::

	ld	iy, #ascii_victory_string
	call drawLevelEndedMenu

	ld	hl, #CKey_NextLevel
	ld	(_keyToCheck), hl
	call waitUntilKeyPressed
	call clean_screen
	
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Man Defeat Menu
;; -------------------------------------------------------------
;;   Draws the end of level menu when defeat conditions
;; are achieved and manages it
;; INPUT: -
;; DESTROYS: -
;;
man_defeatMenu::

	call man_mainMenu_reference

	ld	iy, #ascii_defeat_string
	call drawLevelEndedMenu

	ld	hl, #CKey_RestartLevel
	ld	(_keyToCheck), hl
	call waitUntilKeyPressed
	call clean_screen

	ret


;; ==========================================================================
;; PRIVATE FUNCTIONS
;; ==========================================================================



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Draw play menu
;; -------------------------------------------------------------
;; 	 Draws the main menu
;; INPUT: -
;; DESTROYS: AF, BC, DE, HL, IX, IY
;;
draw_play_menu:

	ld 	de, #0xFFFF
	ld 	hl, #_mainmenu_end

	call cpct_zx7b_decrunch_s_asm

	;; Draw [1]PLAY
	ld	de, #screen_start
	push de
  ld	b, #mainMenu_Y_coord			;; [Y] coordinate
  ld	c, #mainMenu_X_coord  		;; [X] coordinate
  call	cpct_getScreenPtr_asm		;; Returns Video Memory position in HL	
  		
  ;; HL points to video memory
  ld	iy, #ascii_play_string
  call myfunc_drawString

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;; Draw [2]OPTIONS
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	pop de
  ld	b, #mainMenu_Y_coord + 16	;; [Y] coordinate
  ld	c, #mainMenu_X_coord  		;; [X] coordinate
  call	cpct_getScreenPtr_asm		;; Returns Video Memory position in HL	

  ;; HL points to video memoryTODO
	ld	iy, #ascii_options_string
  call myfunc_drawString

	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Clean play menu
;; -------------------------------------------------------------
;; 	 Cleans the main menu
;; INPUT: -
;; DESTROYS: AF, BC, DE, HL, IX, IY
;;
clean_play_menu:
	ld	l, #0
	ld	h, #0
	call cpct_setDrawCharM0_asm
  
	call draw_play_menu

	ld	h, #mainMenu_background_color
	ld	l, #mainMenu_foreground_color
	call cpct_setDrawCharM0_asm
  
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Draw Options Menu
;; -------------------------------------------------------------
;;   Draws the options menu
;; INPUT: -
;; DESTROYS: AF, BC, DE, HL, IX, IY
;;
draw_options_menu:

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;; Draw [Esc]Back
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	  ;; HL points to video memory
ld	de, #screen_start
  ld	b, #mainMenu_Y_coord 			;; [Y] coordinate
  ld	c, #mainMenu_X_coord  				;; [X] coordinate
  call	cpct_getScreenPtr_asm				;; Returns Video Memory position in HL	
	
  ld	iy, #ascii_controls1_string
  call myfunc_drawString

  ;; HL points to video memory
  ld	de, #screen_start
  ld	b, #mainMenu_Y_coord + 16			;; [Y] coordinate
  ld	c, #mainMenu_X_coord  				;; [X] coordinate
  call	cpct_getScreenPtr_asm				;; Returns Video Memory position in HL	
	
  ld	iy, #ascii_controls2_string
  call myfunc_drawString
	
  ;; HL points to video memory
  ld	de, #screen_start
  ld	b, #mainMenu_Y_coord + 32			;; [Y] coordinate
  ld	c, #mainMenu_X_coord  				;; [X] coordinate
  call	cpct_getScreenPtr_asm				;; Returns Video Memory position in HL	
	
  ld	iy, #ascii_controls3_string
  call myfunc_drawString
	

  ;; HL points to video memory
	ld	de, #screen_start
  ld	b, #mainMenu_Y_coord + 60			;; [Y] coordinate
  ld	c, #mainMenu_X_coord  				;; [X] coordinate
  call	cpct_getScreenPtr_asm				;; Returns Video Memory position in HL	
	
  ld	iy, #ascii_back_string
  call myfunc_drawString

	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   Clean Options Menu
;; -------------------------------------------------------------
;; INPUT: -
;; DESTROYS: AF, BC, DE, HL, IX, IY
;;
clean_options_menu:
	ld	l, #0
	ld	h, #0
	call cpct_setDrawCharM0_asm
  
	call draw_options_menu

	ld	h, #mainMenu_background_color
	ld	l, #mainMenu_foreground_color
	call cpct_setDrawCharM0_asm
  
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Manage Options Menu
;; ------------------------myfunc_drawString-------------------------------------
;;   Waits user input to return to main menu (TODO: Add more options in future)
;; INPUT: -
;; DESTROYS: A, D, BC, HL
;;
manageOptionsMenu:
	optionsMenu_loop:
	;{
	;	call    cpct_scanKeyboard_f_asm

		ld      hl, #CKey_GoToMainMenu
		call    cpct_isKeyPressed_asm
		jr      z, GoToMainMenu_NotPressed

		GoToMainMenu_Pressed:
			call clean_options_menu
			call draw_play_menu
			ret
		GoToMainMenu_NotPressed:
			jr optionsMenu_loop
	;}


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Draw Level Ended Menu
;; -------------------------------------------------------------
;; 	 Draws a menu showing the result of the level (Victory or Defeat)
;; INPUT: 
;;     IY: Pointer to ascii string to print
;; DESTROYS: AF, BC, DE, HL, IX, IY
;;
drawLevelEndedMenu:

	ld	de, #screen_start
	push de
  ld	b, #endMenu_Y_coord 					;; [Y] coordinate
  ld	c, #endMenu_X_coord  				;; [X] coordinate
  call	cpct_getScreenPtr_asm				;; Returns Video Memory position in HL	

  call myfunc_drawString				;; Draws IY content
	pop de

	;; DRAW RESTART STRING 1
	push de
	ld iy, #ascii_restart_string1

	ld	b, #endMenu_Y_coord + 16				;; [Y] coordinate
	ld	c, #endMenu_X_coord  				;; [X] coordinate
	call	cpct_getScreenPtr_asm				;; Returns Video Memory position in HL	

  call myfunc_drawString				;; Draws IY content
	pop de

	;; DRAW RESTART STRING 2
	ld iy, #ascii_restart_string2

	ld	b, #endMenu_Y_coord + 24				;; [Y] coordinate
	ld	c, #endMenu_X_coord  				;; [X] coordinate
	call	cpct_getScreenPtr_asm				;; Returns Video Memory position in HL	

  	call myfunc_drawString				;; Draws IY content
	
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Wait Until Key Pressed
;; -------------------------------------------------------------
;; 	 Loops until user presses a key
;; INPUT: 
;;     HL: Pointer to key to check
;; DESTROYS: AF, BC, DE, HL
;;
waitUntilKeyPressed:
	waitKey_loop:
	;{
		;call    cpct_scanKeyboard_f_asm

		_keyToCheck = . + 1
			ld	hl, #0x0000
			call    cpct_isKeyPressed_asm
			jr      z, waitKey_loop

			ret
	;}

;;
;;
;;
clean_screen:
	;; CLEAN WHOLE SCREEN
		ld de, #screen_start
		ld 	a, #00
		ld  c, #40
		ld  b, #200
		call cpct_drawSolidBox_asm
		ld de, #screen_start
		ld  c, #40
		ld  b, #0
		call cpct_getScreenPtr_asm
		ex de,hl
		ld 	a, #00
		ld  c, #40
		ld  b, #200
		call cpct_drawSolidBox_asm
	ret