;;
;;  PATROL MANAGER
;;

.include "man/patrol.h.s"
.include "cmp/entity.h.s"

;;
;;	GLOBAL PATROLS
;;

;; X AXIS PATROLS
_patrol_dont_move:
      .db   patrol_invalid_move_x
      .dw   _patrol_dont_move

_patrol_lvl1_1:
      .db    4, 4, 4, 4
      .db   14, 14, 14, 14
      .db   patrol_invalid_move_x
      .dw   _patrol_lvl1_1


_patrol_lvl1_2:
      .db   60, 60, 60, 60
      .db   70, 70, 70, 70
      .db   patrol_invalid_move_x
      .dw   _patrol_lvl1_2

;; X AND Y AXIS PATROLS
_patrol_01:
	.db   6,   6
	.db  40,  40
      .db  30, 120
	.db	2,  50
	.db    patrol_invalid_move_x
	.dw    _patrol_01

_patrol_02:
    .db   40,   10
    .db   30,  130
    .db   70,  150
    .db   60,   90
    .db   10,   40
    .db   patrol_invalid_move_x
    .dw   _patrol_02


 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAN_PATROL::GET
;;  Returns a patrol depending on the number selected.
;; INPUT:
;;  A = Patrol number (0, 1, 2, ...)
man_patrol_get::
    or      a					;; A = 0
	jr     nz, _p2				;; 

_p1:    
    ld      hl, #_patrol_01
    ret

_p2:  
    ld      hl, #_patrol_02
    ret

	ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	MAN_PATROL::INIT
;;		Sets patrol for all entities
;;	INPUT:
;;		HL -> Entity array
;;
man_patrol_init::
	;; First patrol will be patrol_id 0
  	ld  (_ent_array_ptr), hl    ;; [6]

      _ent_array_ptr = .+2
      ld  ix, #0x0000             ;; [4]	IX = Entity array

      ld		 b, #1			;; B = patrol id
_loop:
	;; Exit on invalid entity
	ld	 	 a, e_w(ix)
	cp		#e_w_invalidEntity
	ret		 z

	;; Check if it has AI
	ld		 a, e_ai_st(ix)
	cp		#e_ai_st_noAI
	jr		 z, _no_AI_ent

	;; Entity has AI, set patrol
	;ld		 a, b
	;call	man_patrol_get
	;ld		 e_ai_patrol_step_l(ix), l
	;ld		 e_ai_patrol_step_h(ix), h
	;inc		 b

_no_AI_ent:
	;; Jump to next entity
	ld		de, #sizeof_e
	add		ix, de
	
	jr		_loop

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	MAN_PATROL::DELETE
man_patrol_delete::
	ret