;;
;;	SYS_LEVEL_RENDERER
;;      Renders the different levels of the game
;;
;;

.include "cpct_functions.h.s"
.include "sys/render.h.s"
.include "assets/assets.h.s"
.include "man/level.h.s"
.include "sys/level.h.s"



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SYS_LEVEL::INIT
;; --------------------------------------------------------------
;;   Inits the render system
;;
sys_lvl_init::
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SYS_LEVEL::DELETE
sys_lvl_delete::
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  SYS_LEVEL::RENDER_LEVEL
;; -----------------------------------------
;;  Renders a level
sys_lvl_render_level::
    ;;; Set drawing parameters
    ld       c, #20                             ;; Width of the screen
    ld       b, #screen_tile_height             ;; Height of the screen
    ld      de, #screen_tile_width              ;; Width of the map
    ld      hl, #_sp_tileset_tutorial_00        ;; Tileset
    call    cpct_etm_setDrawTilemap4x8_ag_asm

    ;;  Draw the tilemap
    call    man_level_get_current_level         ;; DE = level
    ld      hl, #screen_start                   ;; Beginning of the screen
    call    cpct_etm_drawTilemap4x8_ag_asm

    ld      de, #_game_song
    call    cpct_akp_musicInit_asm
    
    ret